<?php

/*
Plugin Name: Blog in Blog
Plugin URI: http://informationtakesover.co.uk/blog-in-blog-wordpress-plugin/
Description: Create a blog within a blog using a category. This plugin basically shows posts in a category on a page using shortcodes.
Version: 0.9.9
Author: Tim Hodson
Author URI: http://timhodson.com
Text Domain: blog-in-blog
*/
/*  Copyright 2009  Tim Hodson  (email : tim@timhodson.com)

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/

/*
* [blog_in_blog category_id= num= template='']
* Assume most recent first (it's supposed to be a mini blog)
*/

include_once( WP_PLUGIN_DIR."/blog-in-blog/options.php" );



$plugin_dir = basename(dirname(__FILE__));
load_plugin_textdomain( 'blog-in-blog', 'wp-content/plugins/' . $plugin_dir, $plugin_dir );


function blog_in_blog_func($atts) {
	global $blog_in_blog_opts;
	global $wp_query;

	extract(shortcode_atts(array (
	'category_id' => '1',
	'num' => '10',
	'order_by' => 'date',
	'template' => $blog_in_blog_opts['bib_post_template'],
	'pagination' => 'on',
	'sort' => 'newest'
	), $atts));

	$blog_in_blog_opts['cat'] = $category_id;
	$blog_in_blog_opts['num'] = $num;
	$blog_in_blog_opts['post_order'] = bib_set_post_order($sort);
	
	if ( file_exists( WP_CONTENT_DIR . '/uploads/' . $template ) ) {
		$blog_in_blog_opts['bib_post_template'] = WP_CONTENT_DIR . '/uploads/' . $template;
	}
	else if (file_exists(WP_PLUGIN_DIR . "/blog-in-blog/" . $template)){
		$blog_in_blog_opts['bib_post_template'] = WP_PLUGIN_DIR . "/blog-in-blog/" . $template ;
	}
	else //use defualt
	{
		$blog_in_blog_opts['bib_post_template'] = WP_PLUGIN_DIR . "/blog-in-blog/". "bib_post_template.tpl";
	}
	
	// get some posts for that category
	
	$out = "";
 
	$blog_in_blog_opts['offset'] = $wp_query->query['offset'];
	//	var_dump($wp_query->query);
	//	echo "offset : $nextoffset";

	$params = array (
	'numberposts' => $num,
	'orderby' => $order_by,
	'order' => $blog_in_blog_opts['post_order'] ,
	'offset' => $blog_in_blog_opts['offset'],
	'category' => $category_id
	);

	$postslist = get_posts($params);
	//	$postslist = get_posts(array_merge($params, $wp_query->query));

	if($blog_in_blog_opts['bib_debug'] ) {
		echo "<h2>Params passed to get_posts()</h2>";
		var_dump($params);
		
		echo "<h2>Response from get_posts()</h2>";
		var_dump($postslist);
	}
	foreach ($postslist as $post) {

		//var_dump($post);

		$data['post_id'] = $post->ID;

		$data['post_date'] = date_i18n($blog_in_blog_opts['date_format'], strtotime($post->post_date));
		$data['post_time'] = date_i18n($blog_in_blog_opts['time_format'], strtotime($post->post_date));
		$data['post_day'] = date_i18n('j', strtotime($post->post_date));
		$data['post_dw'] = date_i18n('D', strtotime($post->post_date));
		$data['post_dow'] = date_i18n('l', strtotime($post->post_date));
		$data['post_mon'] = date_i18n('M', strtotime($post->post_date));
		$data['post_month'] = date_i18n('F', strtotime($post->post_date));
		$data['post_year'] = date_i18n('Y', strtotime($post->post_date));
		$data['post_yr'] = date_i18n('y', strtotime($post->post_date));

		$data['post_title'] = $post->post_title;

		$user = get_userdata( $post->post_author );
		$data['post_author'] = $user->display_name;
		//var_dump($data['post_author']);
		$data['post_author_avatar'] = get_avatar( $post->post_author , $blog_in_blog_opts['bib_avatar_size'] );

		#$data['post_content'] = apply_filters('the_content', $post->post_content);
		$data['post_content'] = $post->post_content;
		
		#$data['post_excerpt'] = apply_filters('the_excerpt', bib_process_excerpt($post) );
		$data['post_excerpt'] = bib_process_excerpt($post) ;
		
		$data['post_permalink'] = get_permalink($post);
		$data['post_comments'] = bib_process_comments($post->comment_status, $post->comment_count, $data['post_permalink']);
		$data['post_tags'] = bib_get_the_tags($post->ID) ;

		$cats = get_the_category($post->ID);
		$catstr="";
		foreach ($cats as $v)
		{
			$cat_link = get_category_link( $v->cat_ID);
			$catstr .= ' <a href="'.$cat_link.'" title="'.$v->cat_name.'" >'.$v->cat_name.'</a>'.$blog_in_blog_opts['bib_text_delim'];

		}
		$catstr = substr($catstr, 0, strlen($catstr) - strlen($blog_in_blog_opts['bib_text_delim']));
		$data['post_categories'] = $catstr;

		$data = bib_process_moretag($data);

		$out .= bib_parse_template($data);
	}

	if($pagination == 'on'){

		$out .= blog_in_blog_page_navi();
		// func - get page navi

	}

	// return the posts data.
	return $out;
}
add_shortcode('blog_in_blog', 'blog_in_blog_func');

/**
 * set the order clause of our query
 */
function bib_set_post_order($order){
		global $blog_in_blog_opts;
		
		if(isset($order)){
			if ($order == "ascending" || $order == "oldest" || $order == "reverse" || $order == "ASC"){
				return 'ASC';
				
			}
			else if ($order == "desending" || $order == "newest" || $order == "forward" || $order == "DESC") {
				return 'DESC';
			}
			else
			{
				return 'DESC';
			}
		}
		else
		{
			return 'DESC';
		}
		
}


/**
 * parse template string
 */
function bib_parse_template($data) {
	global $blog_in_blog_opts;

	// get template string from options
	if( file_exists( $blog_in_blog_opts['bib_post_template'] ) ) {
		
		$template = file_get_contents( $blog_in_blog_opts['bib_post_template'] );
		
		// post id
		$template = str_replace("%post_id%", $data['post_id'], $template);
		
		// dates
		$template = str_replace("%post_date%", $data['post_date'], $template);
		$template = str_replace("%post_time%", $data['post_time'], $template);
        $template = str_replace("%post_day%", $data['post_day'], $template);
        $template = str_replace("%post_dw%", $data['post_dw'], $template);
        $template = str_replace("%post_dow%", $data['post_dow'], $template);
        $template = str_replace("%post_mon%", $data['post_mon'], $template);
        $template = str_replace("%post_month%", $data['post_month'], $template);
        $template = str_replace("%post_year%", $data['post_year'], $template);
        $template = str_replace("%post_yr%", $data['post_yr'], $template);
		$template = str_replace("%post_title%", $data['post_title'], $template);
		
		// author
		$template = str_replace("%post_author%", $data['post_author'], $template);
		$template = str_replace("%post_author_avatar%", $data['post_author_avatar'], $template);
		
		// content
		$template = str_replace("%post_content%", $data['post_content'], $template);
		$template = str_replace("%post_excerpt%", $data['post_excerpt'] , $template);
		
		// post meta
		$template = str_replace("%post_permalink%", $data['post_permalink'], $template);
		$template = str_replace("%post_categories%", $data['post_categories'], $template);
		$template = str_replace("%post_comments%", $data['post_comments'], $template);
		$template = str_replace("%post_tags%", $data['post_tags'], $template);
	}
	else
	{

		$template="<p>[blog_in_blog] Can't read the template file: $filename</p>";
	}


	return $template;
}

/**
 * Process comment data and build a string
 */
function bib_process_comments($cStatus, $cCount, $permalink){

	if ( ( $cStatus == 'open' && $cCount > 0 ) || ( $cStatus == 'closed' && $cCount > 0 ) ) {

		$out= '<a href="'.$permalink.'#comments" title="'.__('Comments','blog-in-blog').'" >'
		. sprintf( __ngettext('%d Comment', '%d Comments', $cCount , 'blog-in-blog').' &raquo;', $cCount).'</a>';

	}
	elseif ($cStatus == 'open'){

		$out= '<a href="'.$permalink.'#respond" title="'.__('Respond', 'blog-in-blog').'" >'
		. __('Leave a response ', 'blog-in-blog').'&raquo;</a>';

	}
	elseif($cStatus == 'closed'){

		$out .= __('Comments are closed', 'blog-in-blog');

	}


	return $out;
}

/**
 * based on get_the_content() in wp-includes/post-template.php
 */
function bib_process_moretag($data) {
	global $blog_in_blog_opts;
	global $more, $multipage, $page;
	$more = 0;

	$output = '';
	$hasTeaser = false;
	$more_link_text = $blog_in_blog_opts['bib_more_link_text'];

	if (preg_match('/<!--more(.*?)?-->/', $data['post_content'], $matches)) {
		$content = explode($matches[0], $data['post_content'], 2);
		if (!empty ($matches[1]) && !empty ($more_link_text))
		$more_link_text = strip_tags(wp_kses_no_null(trim($matches[1])));

		$hasTeaser = true;
		//$more = 0;

	} else {
		$content = array (
		$data['post_content']
		);
		// $more = 1;
	}

	if ((false !== strpos($data['post_content'], '<!--noteaser-->')) && ((!$multipage) || ($page == 1))) {
		$stripteaser = 1;

	}
	$teaser = $content[0];

	if (($more) && ($stripteaser) && ($hasTeaser)){
		//    if ( ($more) && ($hasTeaser) )

		$teaser = '';

	}

	$output .= $teaser;

	if (count($content) > 1) {
		if ($more) {

			$output .= '<span id="more-' . $data['post_id'] . '"></span>' . $content[1];
		} else {

			if (!empty ($more_link_text))
			$output .= apply_filters('the_content_more_link', ' <a href="' . $data['post_permalink'] . "#more-{$data['post_id']}'\" class=\"more-link\">$more_link_text</a>", $more_link_text);
			$output = force_balance_tags($output);
		}

	}

	$data['post_content'] = $output;
	return $data;

}

function bib_process_excerpt($post) {
    
	//var_dump($post);
	$output = $post->post_excerpt;
	
    if ( post_password_required($post) ) {
        $output = __('There is no excerpt because this is a protected post.');
        return $output;
    }
	
    #return apply_filters('get_the_excerpt', $output);	
    return $output;	
}


/**
 * Func to get permalink and make sure there is a ? ready for params.
 */
function bib_get_permalink() {

	// check for existing /?.*=.*/
	//if not found add ? to end of url
	$perma_link = get_permalink();
	if (preg_match('/\?.*\=.*/', $perma_link)){
			return $perma_link;
	}
	else
	{
		$perma_link = $perma_link."?";
		return $perma_link;
	}
}

function bib_get_the_tags($postid) {
	global $blog_in_blog_opts;	
	
	$out='';
	$tags = get_the_tags($postid) ;
	
	if (is_array($tags))
	{
		foreach ($tags as $tag)
		{
			//Get the tag name
			$tag_name = $tag->name; 
			//Get the tag url
			$tag_url = $tag->slug;
			if (get_option('tag_base'))
			{
				$the_url = get_bloginfo('url').'/'.get_option('tag_base');
			}
			else
			{
				$the_url = get_bloginfo('url').'/tag';
				
			}
			
			//Start adding all the linked tags into a single string for the next step 
			$out = $out.'<a href="'.$the_url.'/'.$tag_url.'/">'.$tag_name.'</a>'.$blog_in_blog_opts['bib_text_delim'].' ' ;
			
			
		}
		
		//strip trailing delim and space.
		$out = substr($out, 0, strlen($out) - (strlen($blog_in_blog_opts['bib_text_delim'])+1));
		
	}
	
	return $out;
}
/**
 * Page navi
 */
function blog_in_blog_page_navi() {
	global $blog_in_blog_opts;

	// count pages in chosen category
	$catposts = bib_get_post_count();
	$num = $blog_in_blog_opts['num'];

	$dlimit = $blog_in_blog_opts['bib_show_dots_after'];
	$elipsis = " ...";
	$page = 0;
	$maxpages = floor($catposts / $num);
	$nextoffset = 0;

	$out = '<div style="bib_page_nav">';

	if ($catposts >= 1)
	{
		// show page jumps for every $n posts
		for ($i = 0; $i < $catposts; $i++) {
					
			if ($i % $num == 0) {
				// start a new page, so
				$nextpage = $page++;
				$nextoffset = $thisloop;
				$thisloop++;
				if ($i +1 == $catposts) {
					$lastpage = true;
				}

				// check if this is the current page (based on offset, if offset not set is first page selected
				if ($match == false && (!isset ($blog_in_blog_opts['offset']) || $thisloop -1 == $blog_in_blog_opts['offset'])) {
					
					$selected = ' bib_selected" style="' . $blog_in_blog_opts['bib_style_selected'] . '"';

					$poffset = ($nextoffset - $num);
					$noffset = ($nextoffset + $num);
					$prevlink = ($nextoffset > 0) ? '<a href="' . bib_get_permalink() . '&offset=' . $poffset . '">' . $blog_in_blog_opts['bib_text_previous'] . '</a> ' : $blog_in_blog_opts['bib_text_previous'] . ' ';
					$nextlink = ($noffset < $catposts) ? ' <a href="' . bib_get_permalink() . '&offset=' . $noffset . '">' . $blog_in_blog_opts['bib_text_next'] . '</a>' : ' ' . $blog_in_blog_opts['bib_text_next'];

					$pages[$page]['current'] = true;
					$match = true;
				} else {
					$selected = ' bib_not_selected" style="' . $blog_in_blog_opts['bib_style_not_selected'] . '"';
				}

				// if first page has been output
				if ($first == false) {
					$pout = $blog_in_blog_opts['bib_text_page'] . ' <a href="' . get_permalink() . '" class="bib_page_number' . $selected . '" > ' . $page . '</a>' . $blog_in_blog_opts['bib_text_delim'];
					$pages[$page]['html'] = $pout;
					$first = true;
				} else {
					// only output bib_text_delim and page numbers
					if ($lastpage) {
						$pout = ' <a href="' . bib_get_permalink() . '&offset=' . $nextoffset . '" class="bib_page_number' . $selected . '" >' . $page . '</a>';

					} else {
						$pout = ' <a href="' . bib_get_permalink() . '&offset=' . $nextoffset . '" class="bib_page_number' . $selected . '" >' . $page . '</a>' . $blog_in_blog_opts['bib_text_delim'];
					}
					$pages[$page]['html'] = $pout;
				}
			} else {
				$nextpage = $page;
				$thisloop++;
			}

			//echo "<br />$i, nextpage: $nextpage, thisloop: $thisloop, page: $page, nextoffset: $nextoffset, URLoffset: {$blog_in_blog_opts['offset']}";

			if ($thisloop == $nextpage) {
				// do what exactly?

			}

		}
		//	var_dump($pages);
	}

	if (count($pages) > $dlimit) {
		$max = count($pages);

		$fp = $pages[1]['html'];
		$lp = $pages[$max]['html'];

		foreach ($pages as $k => $page) {
			if ($page['current']) {

				if ($k == 1 || $k == 2 || $k == 3) {
					$fp = '';
					$elipsisa = '';
				}
				elseif ($k == 4) {
					$elipsisa = $blog_in_blog_opts['bib_text_delim'];
				} else {

					$elipsisa = $elipsis;
				}

				$precurr = $pages[$k -2]['html'];
				$precurr .= $pages[$k -1]['html'];
				$current = $pages[$k]['html'];
				$postcurr = $pages[$k +1]['html'];
				//				 trim bib_text_delim from end of string.
				$postcurr .= substr($pages[$k +2]['html'], 0, strlen($pages[$k +2]['html']) - strlen($blog_in_blog_opts['bib_text_delim']));

				if ($k == $max || $k == ($max -1) || $k == ($max -2)) {
					$lp = '';
					$elipsisb = '';
				}
				elseif ($k == ($max -3)) {
					$elipsisb = $blog_in_blog_opts['bib_text_delim'];
				} else {

					$elipsisb = $elipsis;
				}
			}
		}

		$out .= $prevlink . $fp . $elipsisa . $precurr . $current . $postcurr . $elipsisb . $lp . $nextlink;
	} else {
		if (is_array($pages)) {
			foreach ($pages as $page) {
				$pagesout .= $page['html'];
			}
		}
		// remove trailing bib_text_delim
		$pagesout = substr($pagesout, 0, strlen($pagesout) - strlen($blog_in_blog_opts['bib_text_delim']));

		$out .= $prevlink . $pagesout . $nextlink;
	}

	$out .= '</div>';
	//	echo htmlspecialchars($out);
	// return HTML
	return $out;

}

function bib_get_post_count() {
	global $wpdb;
	global $blog_in_blog_opts;
	
	$post_count = 0;
	
	$categories = $blog_in_blog_opts['cat'];

	$querystr = "
				SELECT count
				FROM $wpdb->term_taxonomy, $wpdb->posts, $wpdb->term_relationships
				WHERE $wpdb->posts.ID = $wpdb->term_relationships.object_id
				AND $wpdb->term_relationships.term_taxonomy_id = $wpdb->term_taxonomy.term_taxonomy_id";
				
	if (stristr($categories, ',') === false )
	{
		$querystr .= " 
				AND $wpdb->term_taxonomy.term_id = $categories " ;
	}
	else
	{
		$querystr .= " 
				AND $wpdb->term_taxonomy.term_id in ( $categories )" ;
	}
	
	$querystr .= " 
				AND $wpdb->posts.post_status = 'publish'";
			

	$result = $wpdb->get_var($querystr);
	
	if($blog_in_blog_opts['bib_debug']) {
		echo "<h2>Query string bib_get_post_count()</h2>";
		var_dump($querystr);
		echo ">h2>result bib_get_post_count()</h2>";
		var_dump($result);
	}	
	
	return $result;
}

add_filter('query_vars', 'bib_url_params');
function bib_url_params($qvars) {
	$qvars[] = 'offset';
	return $qvars;
}

/*
* Hide the category chosen to be the blog
*/
function bib_hide_category($notused) {
	global $wp_query;

	$cat = get_option('bib_hide_category');
	if ( is_home() ) {
		//var_dump($cat);
		if (is_array($cat)) {

			foreach ($cat as $v) {

				if($v != "NONE"){
					$c .= '-' . $v . ',';
				}

			}
			$wp_query->query_vars['cat'] = $c;
		}
	}

}

add_action('pre_get_posts', 'bib_hide_category');


function bib_hide_category_feed($query) {

	if (get_option('bib_hide_category_from_rss'))
	{
		if ($query->is_feed) {
			$cat = get_option('bib_hide_category');
			if (is_array($cat)) {
				foreach ($cat as $v){
					if($v != "NONE"){
						$c .= '-' . $v . ',';
					}
				}
			
				$query->set('cat', $c);
			}
		}
    }
    return $query;
}

add_filter('pre_get_posts','bib_hide_category_feed');

// alternative way to hide categories directly in the template page
// if (is_home()) {
//  query_posts("cat=-8");
//}

?>
